/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package project82usb;
import java.io.UnsupportedEncodingException;
import javax.usb.*;
import java.util.*;
/**
 *
 * @author User
 */
public class usbDeviceTree {
    private static final String PREFIX = "   ";
    private final UsbHub rootHub;
    
    public usbDeviceTree() {
        this.rootHub = VirtualRootUsbHub();
    }
    
    private UsbHub VirtualRootUsbHub(){
        UsbServices services = null;
        UsbHub VirtualRootUsbHub = null;
        
        try{
            services = UsbHostManager.getUsbServices();
        } catch (UsbException | SecurityException e){
            throw new RuntimeException("Error : " + e.getMessage());
        }
        
        try {
            VirtualRootUsbHub = services.getRootUsbHub();
        } catch (UsbException | SecurityException e){
            throw new RuntimeException("Error : " + e.getMessage());
        }
        
        return VirtualRootUsbHub;
    }
    
    public UsbHub getVirtualRootUsbHub(){
        return this.rootHub;
    }
    
    public void print(devMatrix out){
        processPrintUsbPorts(rootHub,"",out);
        out.addTextTvOut("");
    }
    
    private void processPrintUsbPorts(UsbDevice device, String prefix, devMatrix out){
        UsbHub hub = null;
        //Проверяем, является ли device хабом
        if(!device.isUsbHub()){
            out.addTextTvOut(prefix+device.toString()+" on port #"+device.getParentUsbPort().getPortNumber());
            return;
        } else{
            hub = (UsbHub)device;
        }
        out.addTextTvOut(prefix+"UsbHub: "+hub.toString().substring(9));
        //Получаем список портов
        List usbPorts = hub.getUsbPorts();
        for(int i=0;i<usbPorts.size();i++){
           UsbPort port = (UsbPort) usbPorts.get(i);
           //Проверяем, подключены ли к порту устройства
           if(!port.isUsbDeviceAttached()){
               out.addTextTvOut(prefix+PREFIX+"usbPort "+port.toString());
           } else{
               processPrintUsbPorts(port.getUsbDevice(),prefix+PREFIX,out);
           }
        }
    }
}
